# Distributed under the OSI-approved BSD 3-Clause License.  See accompanying
# file Copyright.txt or https://cmake.org/licensing for details.

#[===============================================[.rst:
Findmymath
----------

如果能找到库，那么变量 PC_mymath_FOUND 存在，
并且可以得到 mymath 相关的头文件和库目录，存储在以 PC_mymath_XXX 开头的变量中，例如：
PC_mymath_INCLUDE_DIRS（头文件目录）、PC_mymath_LIBRARY_DIRS（库文件目录）、
PC_mymath_LIBRARIES（库名称）等，可通过 man pkg-config 命令查看其它变量。

Imported Targets
^^^^^^^^^^^^^^^^

``mymath::mymath``
  导出 mymath::mymath 可执行目标，我们的测试库并未提供，该处只是一个示意

变量的命名要遵循相关标准，

Result Variables
^^^^^^^^^^^^^^^^

``mymath_FOUND``
  如果找到 mymath 库，该变量值为 True.

``mymath_VERSION``
  mymath 库的版本

``mymath_INCLUDE_DIRS``
  使用 mymath 库需要包含的头文件

``mymath_LIBRARY_DIRS``
  使用 mymath 库需要用到的库文件

Cache Variables
^^^^^^^^^^^^^^^

``mymath_INCLUDE_DIR``
  包含 mymath.h 头文件的目录

``mymath_LIBRARY_DIR``
  mymath 库所在的目录
]===============================================]


find_package(PkgConfig)
pkg_check_modules(PC_mymath QUIET mymath)

# 定义一些缓存变量
find_path(mymath_INCLUDE_DIR
    NAMES mymath.h
    PATHS ${PC_mymath_INCLUDE_DIRS} # PC_mymath_INCLUDE_DIRS 变量由pkg-config提供，下同
    PATH_SUFFIXES mymath)

find_library(mymath_LIBRARY_DIR
    NAMES mymath
    PATHS ${PC_mymath_LIBRARY_DIRS})

set(mymath_VERSION ${PC_mymath_VERSION})
set(mymath_INCLUDE_DIRS "/home/lushuangning/Code/cmake/mymath/include")
set(mymath_LIBRARY_DIRS "/home/lushuangning/Code/cmake/mymath/lib")

# 将变量导出给调用者使用
include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(mymath
    FOUND_VAR mymath_FOUND
    REQUIRED_VARS
        mymath_INCLUDE_DIR
        mymath_LIBRARY_DIR
    VERSION_VAR mymath_VERSION
)
